#define F_CPU 16000000UL  // Assuming a 16 MHz clock

#include <avr/io.h>
#include <util/delay.h>

void setup() {
    // Set pin 2 (PD2) as output
    DDRD |= (1 << PD2);
    // Set pin 4 (PD4) as input
    DDRD &= ~(1 << PD4);
    // Disable internal pull-up for pin 4
    PORTD &= ~(1 << PD4);
}

void loop() {
    // Read pin 4 (PD4)
    bool button_press = PIND & (1 << PD4);
    // Check the state of pin 2 (PD2)
    bool led_state = PIND & (1 << PD2);

    if (button_press && !led_state) {
        // Set pin 2 (PD2) high
        PORTD |= (1 << PD2);
        _delay_ms(300);
    } else if (button_press && led_state) {
        // Set pin 2 (PD2) low
        PORTD &= ~(1 << PD2);
        _delay_ms(300);
    }
}

int main() {
    setup();
    while (1) {
        loop();
    }
}
